/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"time"
)

// checks if the CampaignRecurringConfig type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CampaignRecurringConfig{}

// CampaignRecurringConfig required when recurring is true
type CampaignRecurringConfig struct {
	Frequency string `json:"frequency"`
	Until time.Time `json:"until"`
	ExcludeWeekdays []int32 `json:"exclude_weekdays,omitempty"`
	RescheduleExcluded *bool `json:"reschedule_excluded,omitempty"`
	FrequencyValue int32 `json:"frequency_value"`
	UntilOccurences *int32 `json:"until_occurences,omitempty"`
	CanaryConfig *CampaignRecurringConfigCanaryConfig `json:"canary_config,omitempty"`
}

// NewCampaignRecurringConfig instantiates a new CampaignRecurringConfig object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCampaignRecurringConfig(frequency string, until time.Time, frequencyValue int32) *CampaignRecurringConfig {
	this := CampaignRecurringConfig{}
	this.Frequency = frequency
	this.Until = until
	this.FrequencyValue = frequencyValue
	return &this
}

// NewCampaignRecurringConfigWithDefaults instantiates a new CampaignRecurringConfig object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCampaignRecurringConfigWithDefaults() *CampaignRecurringConfig {
	this := CampaignRecurringConfig{}
	return &this
}

// GetFrequency returns the Frequency field value
func (o *CampaignRecurringConfig) GetFrequency() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Frequency
}

// GetFrequencyOk returns a tuple with the Frequency field value
// and a boolean to check if the value has been set.
func (o *CampaignRecurringConfig) GetFrequencyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Frequency, true
}

// SetFrequency sets field value
func (o *CampaignRecurringConfig) SetFrequency(v string) {
	o.Frequency = v
}

// GetUntil returns the Until field value
func (o *CampaignRecurringConfig) GetUntil() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.Until
}

// GetUntilOk returns a tuple with the Until field value
// and a boolean to check if the value has been set.
func (o *CampaignRecurringConfig) GetUntilOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Until, true
}

// SetUntil sets field value
func (o *CampaignRecurringConfig) SetUntil(v time.Time) {
	o.Until = v
}

// GetExcludeWeekdays returns the ExcludeWeekdays field value if set, zero value otherwise.
func (o *CampaignRecurringConfig) GetExcludeWeekdays() []int32 {
	if o == nil || IsNil(o.ExcludeWeekdays) {
		var ret []int32
		return ret
	}
	return o.ExcludeWeekdays
}

// GetExcludeWeekdaysOk returns a tuple with the ExcludeWeekdays field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignRecurringConfig) GetExcludeWeekdaysOk() ([]int32, bool) {
	if o == nil || IsNil(o.ExcludeWeekdays) {
		return nil, false
	}
	return o.ExcludeWeekdays, true
}

// HasExcludeWeekdays returns a boolean if a field has been set.
func (o *CampaignRecurringConfig) HasExcludeWeekdays() bool {
	if o != nil && !IsNil(o.ExcludeWeekdays) {
		return true
	}

	return false
}

// SetExcludeWeekdays gets a reference to the given []int32 and assigns it to the ExcludeWeekdays field.
func (o *CampaignRecurringConfig) SetExcludeWeekdays(v []int32) {
	o.ExcludeWeekdays = v
}

// GetRescheduleExcluded returns the RescheduleExcluded field value if set, zero value otherwise.
func (o *CampaignRecurringConfig) GetRescheduleExcluded() bool {
	if o == nil || IsNil(o.RescheduleExcluded) {
		var ret bool
		return ret
	}
	return *o.RescheduleExcluded
}

// GetRescheduleExcludedOk returns a tuple with the RescheduleExcluded field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignRecurringConfig) GetRescheduleExcludedOk() (*bool, bool) {
	if o == nil || IsNil(o.RescheduleExcluded) {
		return nil, false
	}
	return o.RescheduleExcluded, true
}

// HasRescheduleExcluded returns a boolean if a field has been set.
func (o *CampaignRecurringConfig) HasRescheduleExcluded() bool {
	if o != nil && !IsNil(o.RescheduleExcluded) {
		return true
	}

	return false
}

// SetRescheduleExcluded gets a reference to the given bool and assigns it to the RescheduleExcluded field.
func (o *CampaignRecurringConfig) SetRescheduleExcluded(v bool) {
	o.RescheduleExcluded = &v
}

// GetFrequencyValue returns the FrequencyValue field value
func (o *CampaignRecurringConfig) GetFrequencyValue() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.FrequencyValue
}

// GetFrequencyValueOk returns a tuple with the FrequencyValue field value
// and a boolean to check if the value has been set.
func (o *CampaignRecurringConfig) GetFrequencyValueOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.FrequencyValue, true
}

// SetFrequencyValue sets field value
func (o *CampaignRecurringConfig) SetFrequencyValue(v int32) {
	o.FrequencyValue = v
}

// GetUntilOccurences returns the UntilOccurences field value if set, zero value otherwise.
func (o *CampaignRecurringConfig) GetUntilOccurences() int32 {
	if o == nil || IsNil(o.UntilOccurences) {
		var ret int32
		return ret
	}
	return *o.UntilOccurences
}

// GetUntilOccurencesOk returns a tuple with the UntilOccurences field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignRecurringConfig) GetUntilOccurencesOk() (*int32, bool) {
	if o == nil || IsNil(o.UntilOccurences) {
		return nil, false
	}
	return o.UntilOccurences, true
}

// HasUntilOccurences returns a boolean if a field has been set.
func (o *CampaignRecurringConfig) HasUntilOccurences() bool {
	if o != nil && !IsNil(o.UntilOccurences) {
		return true
	}

	return false
}

// SetUntilOccurences gets a reference to the given int32 and assigns it to the UntilOccurences field.
func (o *CampaignRecurringConfig) SetUntilOccurences(v int32) {
	o.UntilOccurences = &v
}

// GetCanaryConfig returns the CanaryConfig field value if set, zero value otherwise.
func (o *CampaignRecurringConfig) GetCanaryConfig() CampaignRecurringConfigCanaryConfig {
	if o == nil || IsNil(o.CanaryConfig) {
		var ret CampaignRecurringConfigCanaryConfig
		return ret
	}
	return *o.CanaryConfig
}

// GetCanaryConfigOk returns a tuple with the CanaryConfig field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignRecurringConfig) GetCanaryConfigOk() (*CampaignRecurringConfigCanaryConfig, bool) {
	if o == nil || IsNil(o.CanaryConfig) {
		return nil, false
	}
	return o.CanaryConfig, true
}

// HasCanaryConfig returns a boolean if a field has been set.
func (o *CampaignRecurringConfig) HasCanaryConfig() bool {
	if o != nil && !IsNil(o.CanaryConfig) {
		return true
	}

	return false
}

// SetCanaryConfig gets a reference to the given CampaignRecurringConfigCanaryConfig and assigns it to the CanaryConfig field.
func (o *CampaignRecurringConfig) SetCanaryConfig(v CampaignRecurringConfigCanaryConfig) {
	o.CanaryConfig = &v
}

func (o CampaignRecurringConfig) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CampaignRecurringConfig) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["frequency"] = o.Frequency
	toSerialize["until"] = o.Until
	if !IsNil(o.ExcludeWeekdays) {
		toSerialize["exclude_weekdays"] = o.ExcludeWeekdays
	}
	if !IsNil(o.RescheduleExcluded) {
		toSerialize["reschedule_excluded"] = o.RescheduleExcluded
	}
	toSerialize["frequency_value"] = o.FrequencyValue
	if !IsNil(o.UntilOccurences) {
		toSerialize["until_occurences"] = o.UntilOccurences
	}
	if !IsNil(o.CanaryConfig) {
		toSerialize["canary_config"] = o.CanaryConfig
	}
	return toSerialize, nil
}

type NullableCampaignRecurringConfig struct {
	value *CampaignRecurringConfig
	isSet bool
}

func (v NullableCampaignRecurringConfig) Get() *CampaignRecurringConfig {
	return v.value
}

func (v *NullableCampaignRecurringConfig) Set(val *CampaignRecurringConfig) {
	v.value = val
	v.isSet = true
}

func (v NullableCampaignRecurringConfig) IsSet() bool {
	return v.isSet
}

func (v *NullableCampaignRecurringConfig) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCampaignRecurringConfig(val *CampaignRecurringConfig) *NullableCampaignRecurringConfig {
	return &NullableCampaignRecurringConfig{value: val, isSet: true}
}

func (v NullableCampaignRecurringConfig) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCampaignRecurringConfig) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


